#!/usr/bin/php
<?php
$opt = "";
if (count($argv) > 1) {
	$opt = $argv[1];
}

if (preg_match('/^--general-category=(.+)/', $opt, $re)) {
	$category = $re[1];
	$var_suffix = $re[1];
	$file = "UnicodeData.txt";
	$filter_prefix = $filter_suffix = ";";
}
elseif (preg_match('/^--prop-list=(.+)/', $opt, $re)) {
	$category = $re[1];
	$var_suffix = $re[1];
	$file = "PropList.txt";
	$filter_prefix = "; ";
	$filter_suffix = " #";
	if ($category == "Terminal_Punctuation") {
		$var_suffix = "PTerm";
	}
}
else {
	echo $version, "\n";
	echo "usage: --general-category=<Unicode General Category>\n";
	echo "       --prop-list=<Unicode Prop List>\n";
	exit(1);
}

//
$command = sprintf(
	'awk "/[0-9]+\\.[0-9]+\\.[0-9]+/ {match(\\$0,\"[0-9.]+\\.[0-9]+\\.[0-9]+\"); print substr(\\$0, RSTART, RLENGTH)}" %s/ucd/ReadMe.txt',
	dirname(__FILE__));
$version = trim(exec($command));

//
$command = sprintf(
	'awk -F ";" "/%s%s%s/{print \\$1}" %s/ucd/%s',
	$filter_prefix, $category, $filter_suffix,
	dirname(__FILE__), $file);
exec($command, $lines);

//
$buf = [];
$buf[] = "    // $category letters in $file of Unicode $version";
$buf[] = "    // generated by $argv[0] $argv[1]";
$buf[] = "    /*const*/var REGEX_" . strtoupper($var_suffix) . " = new RegExp('[' + [";
$initial =  "        '";
$tmp = $initial;

if ($category == "Zs") {
	array_unshift($lines, "0009");
}

for ($i = 0; $i < count($lines); $i++) {
	$cp = explode("..", $lines[$i]);
	if (strlen($cp[0]) > 4) continue;
	if (count($cp) == 2 && intval($cp[0], 16) + 1 == intval($cp[1], 16)) {
		array_splice($lines, $i + 1, 0, array_pop($cp));
	}
	$fragment = "\\\\u" . implode("-\\\\u", $cp);
	if (strlen($tmp . $fragment . "',") >= 80) {
		$buf[] = $tmp . "',";
		$tmp = $initial . $fragment;
	}
	else {
		$tmp .= $fragment;
	}
}
if ($tmp != $initial) {
	$buf[] = $tmp . "'";
}
$buf[] = "    ].join('') + ']');";
$buf[] = "";

//
foreach ($buf as $i => $line) {
	$buf[$i] = preg_replace('/    /', "\t", $line);
}

//
echo implode("\n", $buf);
